'*******************************************************************************
' Temperaturregelung fr K4
'
' Autor: Dipl.-Ing. M.Sc. Christian Nding
' Teile des Codes: "WL Electronics" aus dem Robotor-Netz-Forum (http://www.roboternetz.de/community/threads/49014-Mehrere-TSic-auslesen)
' v1.0
' 05.12.2011
'
' Zielhardware: ATtiny2313 mit 20MHz
'*******************************************************************************

$regfile = "attiny2313.dat"                                 ' specify the used micro
$crystal = 8000000                                          ' used crystal frequency
$baud = 38400                                               ' use baud rate
$hwstack = 32                                               ' default use 32 for the hardware stack
$swstack = 10                                               ' default use 10 for the SW stack
$framesize = 40                                             ' default use 40 for the frame space




Config Portb.7 = Output                                     'LED Grn
Config Portb.6 = Output                                     'LED Gelb
Config Portb.5 = Output                                     'LED Rot

Ledgruen Alias Portb.7
Ledgelb Alias Portb.6
Ledrot Alias Portb.5

Config Portd.2 = Input                                      'Tsic-Empfang an INT0

Config Int0 = Falling
On Int0 Int0int
Enable Int0

Enable Interrupts


Dim Sendmessage(5) As Byte
Dim Temperaturword As Word
Dim Myword As Word

Dim Inregister As Word
Dim Bitzaehler As Byte , Parity1 As Byte , Parity2 As Byte
Dim Parity_z1 As Byte , Parity_z2 As Byte , I As Byte
Dim Parity_err As Byte , Messungok As Bit
Dim Timeout As Word , Io As Byte



Set Ledgruen
Set Ledgelb
Set Ledrot
Wait 2
Reset Ledgruen
Reset Ledgelb
Reset Ledrot


'#################################################################################
Do
   Io = 1                                                   'wir nehmen mal an das alles gut wird
   Gosub Neuemessung                                        'Neue Messung vorbereiten

   Do
      Waitms 1 : Incr Timeout
   Loop Until Messungok = 1 Or Timeout > 200                'Telegramm abwarten / "MessungOK" wird in "Int0Int:" generiert
   If Timeout > 200 Then
      Io = 0 : Temperaturword = 0                           '!!! FEHLER !!!
   End If

   Toggle Ledgelb                                           'Lebenszeichen

   If Parity_err > 0 Or Timeout > 200 Then
      Set Ledrot
      Wait 2
      Reset Ledrot
   End If


   Sendmessage(1) = 65
   Sendmessage(2) = Temperaturword
   Myword = Temperaturword
   Shift Myword , Right , 8
   Sendmessage(3) = Myword
   Sendmessage(4) = 69
   Sendmessage(5) = 13
   Printbin Sendmessage(1)

   Waitms 200

   If Io = 1 Then
      Set Ledgruen                                           'Sensor i.O.
   Else
      Reset Ledgruen                                        'Sensor n.i.O.
   End If

Loop
'#################################################################################

End


'________________________________________________________________________________
Neuemessung:
Timeout = 0
Messungok = 0
Parity_err = 0
Inregister = 0
Bitzaehler = 0
Parity_z1 = 0
Parity_z2 = 0
Return


'________________________________________________________________________________
Int0int:

Incr Bitzaehler

Select Case Bitzaehler
   Case 1                                                   'Start-Bit MSB

   Case 2 To 9                                              'Daten MSB
      Waitus 60                                             'ungefhr Mitte (gesamt-Bitbreite=125s)
      Shift Inregister , Left
      If Pind.2 = 1 Then                                    'Bit="1" ?
         Inregister = Inregister Or 1                       'dann rein damit
         Incr Parity_z1                                     '"1"-Bits zhlen
      End If

   Case 10                                                  'Parity-Bit MSB
      Waitus 60
      Parity1 = Parity_z1 Mod 2                             'gerade ?
      If Pind.2 = 1 And Parity1 = 0 Then
         Incr Parity_err                                    'FEHLER !
      End If

   Case 11                                                  'Start-Bit LSB

   Case 12 To 19                                            'Daten LSB
      Waitus 60                                             'ungefhr Mitte (gesamt-Bitbreite=125s)
      Shift Inregister , Left
      If Pind.2 = 1 Then                                    'Bit="1" ?
         Inregister = Inregister Or 1                       'dann rein damit
         Incr Parity_z2                                     '"1"-Bits zhlen
      End If
   Case 20                                                  'Parity-Bit LSB
      Waitus 60
      Parity2 = Parity_z2 Mod 2                             'gerade ?
      If Pind.2 = 1 And Parity2 = 0 Then
         Incr Parity_err                                    'FEHLER !
      End If

      If Parity_err = 0 Then
         Temperaturword = Inregister
         Parity_err = 0
         Inregister = 0
         Bitzaehler = 0
         Parity_z1 = 0
         Parity_z2 = 0
         Messungok = 1
         Waitms 3
      Else
         Temperaturword = 0
         Io = 0                                             'Parity-Fehler
      End If

End Select

Return