'*******************************************************************************
' Temperaturregelung fr K4
'
' Autor: Dipl.-Ing. M.Sc. Christian Nding
' Teile des Codes: "WL Electronics" aus dem Robotor-Netz-Forum (http://www.roboternetz.de/community/threads/49014-Mehrere-TSic-auslesen)
' v1.0
' 05.12.2011
'
' Zielhardware: ATmega32 mit 16MHz (AVR-NET-IO von Pollin)
'*******************************************************************************

$regfile = "m32def.dat"                                     ' specify the used micro
$crystal = 16000000                                         ' used crystal frequency
$baud = 38400                                               ' use baud rate
$hwstack = 32                                               ' default use 32 for the hardware stack
$swstack = 10                                               ' default use 10 for the SW stack
$framesize = 40                                             ' default use 40 for the frame space




Config Portc.4 = Output                                     'Sensor i.O.
Config Portc.5 = Output                                     'Lebenszeichen

Config Portd.2 = Input                                      'Tsic-Empfang an INT0

Config Lcdpin = Pin , Db4 = Portc.0 , Db5 = Portc.1 , Db6 = Portc.2 , Db7 = Portc.3 , E = Portc.6 , Rs = Portc.4
Config Lcd = 16 * 2

Config Int0 = Falling
On Int0 Int0int
Enable Int0

Enable Interrupts


Dim Sendmessage(5) As Byte
Dim Temperaturword As Word
Dim Myword As Word

Dim Inregister As Word
Dim Temperatur As Single
Dim T1$ As String * 16
Dim Bitzaehler As Byte , Parity1 As Byte , Parity2 As Byte
Dim Parity_z1 As Byte , Parity_z2 As Byte , I As Byte
Dim Parity_err As Byte , Messungok As Bit
Dim Timeout As Word , Io As Byte

Display On : Cls
Cursor Off



'#################################################################################
Do
   Io = 1                                                   'wir nehmen mal an das alles gut wird
   Gosub Neuemessung                                        'Neue Messung vorbereiten

   Do
      Waitms 1 : Incr Timeout
   Loop Until Messungok = 1 Or Timeout > 200                'Telegramm abwarten / "MessungOK" wird in "Int0Int:" generiert
   If Timeout > 200 Then
      Io = 0 : Temperatur = -99                             '!!! FEHLER !!!
   End If

   Toggle Portc.5                                           'Lebenszeichen

   If Parity_err > 0 Or Timeout > 200 Then
      Cls
      Upperline
      Lcd "Sensorfehler!"
      Wait 2
      Cls
   End If

   T1$ = Fusing(temperatur , "#.#")

   Upperline
   Lcd "T1=" ; T1$ ; "     "
   Waitms 200


   Sendmessage(1) = 65
   Sendmessage(2) = Temperaturword
   Myword = Temperaturword
   Shift Myword , Right , 8
   Sendmessage(3) = Myword
   Sendmessage(4) = 69
   Sendmessage(5) = 13
   Printbin Sendmessage(1)

   If Io = 1 Then
      Portc.4 = 1                                           'Sensor i.O.
   Else
      Portc.4 = 0                                           'Sensor n.i.O.
   End If

Loop
'#################################################################################

End


'________________________________________________________________________________
Neuemessung:
Timeout = 0
Messungok = 0
Parity_err = 0
Inregister = 0
Bitzaehler = 0
Parity_z1 = 0
Parity_z2 = 0
Return


'________________________________________________________________________________
Int0int:

Incr Bitzaehler

Select Case Bitzaehler
   Case 1                                                   'Start-Bit MSB

   Case 2 To 9                                              'Daten MSB
      Waitus 60                                             'ungefhr Mitte (gesamt-Bitbreite=125s)
      Shift Inregister , Left
      If Pind.2 = 1 Then                                    'Bit="1" ?
         Inregister = Inregister Or 1                       'dann rein damit
         Incr Parity_z1                                     '"1"-Bits zhlen
      End If

   Case 10                                                  'Parity-Bit MSB
      Waitus 60
      Parity1 = Parity_z1 Mod 2                             'gerade ?
      If Pind.2 = 1 And Parity1 = 0 Then
         Incr Parity_err                                    'FEHLER !
      End If

   Case 11                                                  'Start-Bit LSB

   Case 12 To 19                                            'Daten LSB
      Waitus 60                                             'ungefhr Mitte (gesamt-Bitbreite=125s)
      Shift Inregister , Left
      If Pind.2 = 1 Then                                    'Bit="1" ?
         Inregister = Inregister Or 1                       'dann rein damit
         Incr Parity_z2                                     '"1"-Bits zhlen
      End If
   Case 20                                                  'Parity-Bit LSB
      Waitus 60
      Parity2 = Parity_z2 Mod 2                             'gerade ?
      If Pind.2 = 1 And Parity2 = 0 Then
         Incr Parity_err                                    'FEHLER !
      End If

      If Parity_err = 0 Then
         Temperaturword = Inregister
         Temperatur = Inregister / 2047                     'Temperatur = (Digital signal / 2047 * 200 - 50) C  sagt das Datenblatt
         Temperatur = Temperatur * 200
         Temperatur = Temperatur - 50                       'passt !
         Parity_err = 0
         Inregister = 0
         Bitzaehler = 0
         Parity_z1 = 0
         Parity_z2 = 0
         Messungok = 1
         Waitms 3
      Else
         Temperaturword = 0
         Temperatur = -99
         Io = 0                                             'Parity-Fehler
      End If

End Select

Return